Subject: Re: [PATCH net-next] net: dsa: rzn1-a5psw: Add vlan support

From: Clément Léger <[email-masked]>
Date: Mon, 16 Jan 2023 09:08:37 +0100

Le Fri, 13 Jan 2023 17:37:30 +0200,
Vladimir Oltean <[email-masked]> a écrit :

> On Fri, Jan 13, 2023 at 03:12:40PM +0100, Andrew Lunn wrote:
> > On Thu, Jan 12, 2023 at 09:37:55PM -0800, Jakub Kicinski wrote:  
> > > On Wed, 11 Jan 2023 12:56:07 +0100 Clément Léger wrote:  
> > > > Add support for vlan operation (add, del, filtering) on the RZN1
> > > > driver. The a5psw switch supports up to 32 VLAN IDs with filtering,
> > > > tagged/untagged VLANs and PVID for each ports.  
> > > 
> > > noob question - do you need that mutex? 
> > > aren't those ops all under rtnl_lock?  
> > 
> > Hi Jakub
> > 
> > Not commenting about this specific patch, but not everything in DSA is
> > done under RTNL. So you need to deal with some parallel API calls. But
> > they tend to be in different areas. I would not expect to see two VLAN
> > changes as the same time, but maybe VLAN and polling in a workqueue to
> > update the statistics for example could happen. Depending on the
> > switch, some protect might be needed to stop these operations
> > interfering with each other. And DSA drivers in general tend to KISS
> > and over lock. Nothing here is particularly hot path, the switch
> > itself is on the end of a slow bus, so the overhead of locks are
> > minimum.  
> 
> That being said, port_vlan_add(), port_vlan_del() and port_vlan_filtering()
> are all serialized by the rtnl_lock().

Ok then, I'll remove this lock and rely on the RTNL lock.

Thanks,

-- 
Clément Léger,
Embedded Linux and Kernel engineer at Bootlin
https://bootlin.com